import os
import sys
from multiprocessing import Process

import rq

src_root = os.path.join(os.path.abspath(__file__).split('bin')[0], 'src')
sys.path.append(src_root)

from config import Config
from connection import Connection


def start_worker(config):
    connection = Connection(config)

    with rq.Connection(connection=connection.redis_conn):
        rq.Worker(['default']).work()


if __name__ == '__main__':
    manage_path = os.path.dirname(os.path.abspath(__file__))
    config_yml_path = os.path.join(os.path.dirname(manage_path), 'config', 'config.yml')

    config = Config()
    config.load(config_yml_path)

    # process_list = []
    # for i in range(int(config.common.WORKER_NUM)):
    #     process_list.append(Process(target=start_worker, args=(config,)))
    #
    # for p in process_list:
    #     p.start()
    # for p in process_list:
    #     p.join()

    start_worker(config)
