import os
from PIL import Image


class CacheFile:

    def __init__(self, storage, formatter):

        self._data = {}

        self._storage   = storage
        self._formatter = formatter

        pass

    def put(self, x, y, z, image):

        pass

    def take(self, x, y, z, blank, date=None):

        extension = 'jpeg'

        fn_jpeg = self._formatter.format(x, y, z, extension)

        if date:

            c_filename_dict = self._storage.path(date).find_ox_oy(fn_jpeg)

            filename = self._storage.path(date).resolve(fn_jpeg)

        else:
            c_filename_dict = self._storage.find_ox_oy(fn_jpeg)

            filename = self._storage.resolve(fn_jpeg)

        if c_filename_dict:
            return Image.open(c_filename_dict['filename']), {'extension': extension, 'ox': c_filename_dict['ox'], 'oy': c_filename_dict['oy']}

        if os.path.exists(filename):
            return Image.open(filename), {'extension': extension, 'ox': 0, 'oy': 0}

        extension = 'png'

        fn_png = self._formatter.format(x, y, z, extension)

        if date:

            c_filename_dict = self._storage.path(date).find_ox_oy(fn_png)

            filename = self._storage.path(date).resolve(fn_png)

        else:
            c_filename_dict = self._storage.find_ox_oy(fn_png)

            filename = self._storage.resolve(fn_png)

        if c_filename_dict:
            return Image.open(c_filename_dict['filename']), {'extension': extension, 'ox': c_filename_dict['ox'], 'oy': c_filename_dict['oy']}

        if os.path.exists(filename):
            return Image.open(filename).convert('RGB'), {'extension': extension, 'ox': 0, 'oy': 0}

        return blank, {'ox': 0, 'oy': 0}

    pass


class CacheMemory:

    def __init__(self, dictionary):

        self._dictionary = dictionary

        pass

    def put(self, x, y, z, image):

        self._dictionary[(x, y, z)] = image

        pass

    def take(self, x, y, z, blank, date=None):

        return self._dictionary.pop((x, y, z), blank), None

    pass
