import os
import shutil
import subprocess


def cog_convert(input_path, output_path, txt_enable):

    for root, dirs, files in os.walk(input_path):

        for tif_name in files:

            name, ext = os.path.splitext(tif_name)
            ext = ext.strip('.').lower()
            if ext not in ['tif', 'tiff', ]:
                continue

            relative_path = root[len(input_path):]

            output_path = os.path.join(output_path, relative_path.strip('/'))

            if not os.path.exists(output_path):
                os.makedirs(output_path, exist_ok=True)

            src_tif_path = os.path.join(root, tif_name)
            dst_tif_path = os.path.join(output_path, tif_name)

            # 如果gdal_translate命令不存在环境便令中，需要指定具体的路径
            # cmd = "/usr/softwares/GDAL/bin/gdal_translate {} {} -of COG -co TILING_SCHEME=GoogleMapsCompatible -co COMPRESS=LZW".format(src_tif_path, dst_tif_path)

            cmd = "gdal_translate {} {} -of COG -co TILING_SCHEME=GoogleMapsCompatible -co COMPRESS=LZW".format(src_tif_path, dst_tif_path)

            p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

            p.wait()

            src_txt_path = os.path.join(root, name + '.txt')

            # 是否拷贝txt文件，如果拷贝txt文件则先判断txt文件是否存在
            if txt_enable and os.path.exists(src_txt_path):
                shutil.copy(src_txt_path, output_path)
