import os


class Filename:

    def __init__(self, path):

        if not os.path.exists(path):

            raise Exception(f"{path} not exist.")

        if not os.path.isfile(path):

            raise Exception(f"{path} is not a file.")

        directory, target = os.path.split(path)

        name, extension = os.path.splitext(target)

        geojsonl = os.path.join(directory, f"{name}.geojsonl")

        self._directory = directory
        self._name = name

        self._value = os.path.join(directory, f"{target}")

        self._geojsonl = geojsonl if os.path.exists(geojsonl) else None

        pass

    def __str__(self):

        return self._value

    @property
    def directory(self):

        return self._directory

    @property
    def name(self):

        return self._name

    @property
    def geojsonl(self):

        return self._geojsonl

    pass
