from starearth.filesystem.filesystem import FileSystem
from starearth.filesystem.cache import FileSystemCache


class FileSystemFactory:

    def __init__(self):
        self._creators = {
            'FileSystem': FileSystem,
            'FileSystemCache': FileSystemCache,
        }

    _instance = None

    @staticmethod
    def _singleton():
        if FileSystemFactory._instance is None:
            FileSystemFactory._instance = FileSystemFactory()

            pass

        return FileSystemFactory._instance

    @staticmethod
    def create(name, *args):

        instance = FileSystemFactory._singleton()

        if name not in instance._creators.keys():
            raise Exception('{} is invalid '.format(name))

        creator = instance._creators[name]

        if creator is None:
            # return None # 或者 raise 'unsupported object type'

            raise Exception('unsupported object type')

        return creator(*args)

    @staticmethod
    def register(name, creator):

        instance = FileSystemFactory._singleton()

        instance._creators[name] = creator

        pass

    pass