import os
import shutil


class FileSystemCache:
    # TODO yue.zijian & jin.qingchun
    def __init__(self, tmp_geotiff='./', tmp_tiles='./', tmp_ptp='./'):
        self.tmp_geotiff = self._ensure(tmp_geotiff)
        self.tmp_tiles = self._ensure(tmp_tiles)
        self.tmp_ptp = self._ensure(tmp_ptp)
        self.file_list = []
        pass

    def __enter__(self):
        return self

    def __exit__(self, exc_type, exc_val, exc_tb):
        # # 删除缓存的瓦片目录
        # shutil.rmtree(self.tmp_tiles)
        # os.makedirs(self.tmp_tiles, exist_ok=True)
        #
        # # os.system('rm -rf %s' % self.tmp_tiles)
        # # os.system('mkdir %s' % self.tmp_tiles)
        #
        # for each_path in self.file_list:
        #     # 删除缓存的原始文件(*.tif/*.ovr/*.tfw/*.geojsonl)
        #     if os.path.exists(each_path):
        #         os.remove(each_path)
        #
        #     # os.system('rm -rf %s' % each_path)
        #
        # # 删除缓存的临时ptp
        # shutil.rmtree(self.tmp_ptp)
        # os.makedirs(self.tmp_ptp, exist_ok=True)
        #
        # # os.system('rm -rf %s/*' % self.tmp_ptp)
        pass

    def resolve(self, path):
        """下载影像和元数据到/cache缓存目录"""
        file_path = os.path.join(self.tmp_geotiff, os.path.basename(path))
        if os.path.exists(path):
            shutil.copy(path, file_path)
            self.file_list.append(file_path)

        tif_ovr = path + '.ovr'
        new_tif_ovr = os.path.join(self.tmp_geotiff, os.path.basename(tif_ovr))
        if os.path.exists(tif_ovr):
            shutil.copy(tif_ovr, new_tif_ovr)
            self.file_list.append(new_tif_ovr)

        tif_tfw = os.path.splitext(path)[0] + '.tfw'
        new_tif_tfw = os.path.join(self.tmp_geotiff, os.path.basename(tif_tfw))
        if os.path.exists(tif_tfw):
            shutil.copy(tif_tfw, new_tif_tfw)
            self.file_list.append(new_tif_tfw)
        return file_path

    def _ensure(self, path):

        if not os.path.exists(path):
            
            os.makedirs(path, exist_ok=True)

            pass

        return str(path)

    pass