import glob
import os


class FileSystem:

    def __init__(self, root='./'):

        self._root = self._ensure(root)

        self._paths = {}

        pass

    def __str__(self):

        return self._root

    def path(self, name):

        if name not in self._paths:

            path = self._ensure(os.path.join(self._root, name.strip('/')))

            self._paths[name] = FileSystem(path)

            pass

        return self._paths[name]

    def resolve(self, name):

        return os.path.join(self._root, name.strip('/'))

    def list(self, extension='*'):

        files = \
            [
                os.path.basename(f) for f in glob.glob(os.path.join(self._root, '*.{}'.format(extension)))
            ]

        return sorted(files)

    def _ensure(self, path):

        if not os.path.exists(path):

            os.makedirs(path, exist_ok=True)

            pass

        return str(path)
