from .grid import Grid

from .ge  import GridGoogleEarth
from .mct import GridMorecantile
from .sm  import GridSupermercado


class GridFactory:

    @staticmethod
    def create(identifier):

        if identifier == Grid.GoogleEarthQuad:

            return GridGoogleEarth(Grid.GoogleEarthQuad)

        if identifier == Grid.WebMercatorQuad:

            return GridSupermercado(Grid.WebMercatorQuad)

        if identifier == Grid.WGS1984Quad:

            return GridMorecantile(Grid.WGS1984Quad)

        return None

    pass


__all__ = \
    [
        'Grid',
        'GridFactory'
    ]

