from morecantile.scripts.cli import coords


class Grid:

    GoogleEarthQuad = "GoogleEarthQuad"
    WebMercatorQuad = "WebMercatorQuad"
    WGS1984Quad     = "WGS1984Quad"

    def __init__(self, identifier):

        self._identifier = identifier

        pass

    @property
    def identifier(self):

        return self._identifier

    def tiles(self, features, z_min, z_max=None):

        return []

    def bound_of(self, x, y, z):

        return None

    def tile_of(self, longitude, latitude, zoom):

        return None

    @staticmethod
    def bound_by(features) -> tuple[float, float, float, float]:

        bound = None

        for feature in features:

            xs = []
            ys = []

            for data in feature.get("features", [feature]):

                lngs, lats = zip(*list(coords(data)))

                xs.extend([min(lngs), max(lngs)])
                ys.extend([min(lats), max(lats)])

                pass

            bound = min(xs), min(ys), max(xs), max(ys)

            pass

        return bound

    pass

