from .grid import Grid

import mercantile

from supermercado import burntiles, super_utils

from starearth import Bound


class GridSupermercado(Grid):

    def __init__(self, identifier):

        super().__init__(identifier)

        pass

    def tiles(self, features, z_min, z_max=None):

        polygons = [f for f in super_utils.filter_features(features)]

        zooms = [z_min] if z_max is None else [z for z in range(z_min, z_max + 1)]

        tiles = []

        for zoom in zooms:

            tiles.extend([tile.tolist() for tile in burntiles.burn(polygons, zoom)])

            pass

        return tiles

    def bound_of(self, x, y, z):

        bbox = mercantile.xy_bounds(x, y, z)

        return Bound.RH(bbox[0], bbox[1], bbox[2], bbox[3])

    def tile_of(self, longitude, latitude, zoom):

        tile = mercantile.tile(longitude, latitude, zoom)

        return tile.x, tile.y, tile.z

    pass
