import numpy as np
from PIL import Image


class Nodata:

    def __init__(self, value):

        self._value = value

        pass

    def process(self, image):

        data = np.asarray(image)

        assert len(self._value) == data.shape[2]

        data_size = (data.shape[0], data.shape[1])

        alpha = np.zeros(data_size, data.dtype)
        # alpha = np.zeros(image.size, data.dtype)

        alpha[np.all(data != self._value, -1)] = 255

        data = np.concatenate((data, np.expand_dims(alpha, axis=-1)), axis=-1)

        return Image.fromarray(data, 'RGBA')

    pass
