import json


class Sheet:

    def __init__(self):

        self.features = None

        self.date = None

        pass

    @staticmethod
    def parse(data):

        features = []

        properties = data['properties']

        date = properties['date']
        date = 'default' if date is None else date

        geometry = data['geometry']

        if geometry['type'] == 'MultiPolygon':

            for coordinates in geometry['coordinates']:

                feature = \
                    {
                        'type':       'Feature',
                        'properties': properties,
                        'geometry':
                            {
                                'type':        'Polygon',
                                'coordinates': coordinates
                            }
                    }

                features.append(feature)

                pass

            pass

        elif geometry['type'] == 'Polygon':

            features.append(data)
            pass

        instance = Sheet()

        instance.date     = date
        instance.features = features

        return instance

    @staticmethod
    def parse_geojsonl(filename):

        sheets = []

        with open(filename) as stream:

            for line in stream.readlines():

                data = json.loads(line.strip())

                sheets.append(Sheet.parse(data))

                pass

            pass

        return sheets

    pass

