from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.pool import NullPool

Base = declarative_base()


def conndb():
    """数据库相关"""
    from config     import Config
    from connection import Connection

    config = Config()
    connection = Connection(config)

    # engine = create_engine(connection.db_uri, pool_size=20, max_overflow=0)
    engine = create_engine(connection.db_uri, poolclass=NullPool)
    DBSession = sessionmaker(bind=engine)

    return DBSession()
